duplicated {base} | R Documentation

## Determine Duplicate Elements

### Description

Determines which elements of a vector of data frame are duplicates of elements with smaller subscripts, and returns a logical vector indicating which elements (rows) are duplicates.

### Usage

    duplicated(x, incomparables = FALSE, ...)

    ## S3 method for class 'array':
    duplicated(x, incomparables = FALSE, MARGIN = 1, ...)

### Arguments

`x` | an atomic vector or a data frame or an array.
`incomparables` | a vector of values that cannot be compared. Currently, `FALSE` is the only possible value, meaning that all values can be compared.
`...` | arguments for particular methods.
`MARGIN` | the array margin to be held fixed: see `apply`.

### Details

This is a generic function with methods for vectors, data frames and arrays (including matrices).

The data frame method works by pasting together a character representation of the rows separated by `\r`, so may be imperfect if the data frame has characters with embedded carriage returns or columns which do not reliably map to characters.

The array method calculates for each element of the sub-array specified by `MARGIN` if the remaining dimensions are identical to those for an earlier element (in row-major order). This would most commonly be used to find duplicated rows (the default) or columns (with `MARGIN = 2`).

### References

Becker, R. A., Chambers, J. M. and Wilks, A. R. (1988) The New S Language. Wadsworth & Brooks/Cole.

### See Also

`unique`.

### Examples

    x <- c(9:20, 1:5, 3:7, 0:8)
    ## extract unique elements
    (xu <- x[!duplicated(x)])
    ## xu == unique(x) but unique(x) is more efficient

    data(iris)
    duplicated(iris)[140:143]

    data(iris3)
    duplicated(iris3, MARGIN = c(1, 3))

[Package Contents]